#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
constexpr ll MOD=998244353;
int n,m;
ll c,f;
int a[1010][1010];
ll col[1010][1010],row[1010][1010];

inline void init()
{
    memset(col,0,sizeof(col));
    memset(row,0,sizeof(row));
    memset(a,0,sizeof(a));
    n=m=c=f=0;
}

inline void readInput()
{
    cin >> n >> m >> c >> f;
    string tmp;
    for(int i=1; i<=n; i++) {
        cin >> tmp;
        for (int j = 0; j < m; j++)
        {
            a[i][j+1]=tmp[j]-'0';
        }
    }
    // for (int i = 1; i <= n; i++)
    // {
    //     for(int j=1; j<=m; j++) {
    //         cout << a[i][j] << ' ';
    //     }
    //     cout << endl;
    // }
}

inline void preCompute()
{
    for(int i=1; i<=n; i++) {
        for(int j=m; j>=1; j--) {
            if(a[i][j]==1) {
                col[i][j]=0;
            }else {
                col[i][j]=col[i][j+1]+1;
            }
        }
    }
    for(int i=1; i<=m; i++) {
        for(int j=n; j>=1; j--) {
            if(a[j][i]==1) {
                row[j][i]=0;
            }else {
                row[j][i]=row[j+1][i]+1;
            }
        }
    }
    // for(int i=1; i<=n; i++) {
    //     for(int j=1; j<=m; j++) {
    //         cout << col[i][j] << ' ';
    //     }
    //     cout << endl;
    // }
    // cout << endl;
    // for(int i=1; i<=n; i++) {
    //     for(int j=1; j<=m; j++) {
    //         cout << row[i][j] << ' ';
    //     }
    //     cout << endl;
    // }
}

inline void solve()
{
    ll ansC=0,ansF=0;
    for(int i=1; i<=n; i++) {
        for(int j=1; j<=m; j++) {
            for(int k=i+2; k<=i+row[i][j]-1; k++) {
                if(col[i][j]>0&&col[k][j]>0) {
                    ansC=(ansC+(col[i][j]-1)*(col[k][j]-1))%MOD;
                    // printf("(%d,%d)-(%d,%d):%d %d\n",i,j,k,j,col[i][j]-1,col[k][j]-1);
                    if(row[k][j]>0){
                        ansF=(ansF+(col[i][j]-1)*(col[k][j]-1)*(row[k][j]-1))%MOD;
                    }
                }
            }            
        }
    }
    cout << ansC*c << ' ' << ansF*f << endl;
}

int main()
{
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
    freopen("plant.in","r",stdin);
    freopen("plant.out","w",stdout);
    int T,id;
    cin >> T >> id;
    for (int i = 0; i < T; i++)
    {
        init();
        readInput();
        preCompute();
        solve();
    }
    return 0;
}